using namespace std;

# include <iostream>
# include <fstream>
# include <kdtree.h>

   int main()
  {
      Real *x[3],d,x0[3]; 
      Int ip,np, it,id,nt;
      cKdTree *kdt;
      ifstream fle;
         
      np = 15;
      x[0] = new Real [np];      
      x[1] = new Real [np];      
      x[2] = new Real [np];      

      fle.open("check.dat");
      for(ip=0; ip<np; ip++) 
     {
         fle >> x[0][ip] >> x[1][ip] >> x[2][ip];
     }
      fle.close();

      kdt= new cKdTree();
      kdt->build( 3,np, x );

      cout << "done with building the tree\n";

      nt = 1000;
     #pragma acc parallel loop \
      private(x0) \
      present(kdt[:1]) \
      default(none)
      for(it=0; it<nt; it++)
     {
         //in real case, x0 will be differnt for each "it" and each search is independent, this is just for test
         x0[0] = 10.;
         x0[1] = 0.0533958 ;
         x0[2] = 9.9;
         kdt->nearest( x0,&id,&d );
         //cout << it << " " << id << " " << d << "\n";
     }

      #pragma acc exit data copyout(kdt[:1])
      delete[] x[0];
      delete[] x[1];
      delete[] x[2];
      delete kdt;

      return 0;
  }

